import json
import requests
from . import config
import os
import time
from threading import Thread
import threading
from pprint import pprint
import sys


api = config.api

threads = config.th
offset = config.offset

vs = '1.1'
__version__ = '{}'.format(vs)

def types(msgs):

    if msgs.get('message', None) is not None:
        msg = msgs['message']

    elif msgs.get('edited_message', None) is not None:
        msg = msgs['edited_message']

    elif msgs.get('channel_post', None) is not None:
        msg = msgs['channel_post']

    elif msgs.get('edited_channel_post', None) is not None:
        msg = msgs['edited_channel_post']

    elif msgs.get('inline_query', None) is not None:
        msg = msgs['inline_query']

    elif msgs.get('chosen_inline_result', None) is not None:
        msg = msgs['chosen_inline_result']

    elif msgs.get('callback_query', None) is not None:
        msg = msgs['callback_query']

    elif msgs.get('shipping_query', None) is not None:
        msg = msgs['shipping_query']

    elif msgs.get('pre_checkout_query', None) is not None:
        msg = msgs['pre_checkout_query']


    return msg


class Th(Thread) :
    def __init__ (self, msgs):
        Thread.__init__(self)
        self.msgs = msgs

    def run(self):

        if self.msgs.get('message', None) is not None:
            msg = self.msgs['message']
            content_type = 'text'
            date = msg['date']

        elif self.msgs.get('edited_message', None) is not None:
            msg = self.msgs['edited_message']
            date = msg['date']

        elif self.msgs.get('channel_post', None) is not None:
            msg = self.msgs['channel_post']
            date = msg['date']

        elif self.msgs.get('edited_channel_post', None) is not None:
            msg = self.msgs['edited_channel_post']
            date = msg['date']
        elif self.msgs.get('inline_query', None) is not None:
            msg = self.msgs['inline_query']
            date = msg['message']['date']
        elif self.msgs.get('chosen_inline_result', None) is not None:
            msg = self.msgs['chosen_inline_result']
            date = msg['message']['date']
        elif self.msgs.get('callback_query', None) is not None:
            msg = self.msgs['callback_query']
            date = msg['message']['date']
        elif self.msgs.get('shipping_query', None) is not None:
            msg = self.msgs['shipping_query']
            date = msg['message']['date']
        elif self.msgs.get('pre_checkout_query', None) is not None:
            msg = self.msgs['pre_checkout_query']
            date = msg['message']['date']
        else:
            return self.msgs

        if (time.time() - date) > config.timer:
            return msg



class _BotBase(object):
    def __init__(self, token):
        self._token = token
        

class Bot(_BotBase):
    def __init__(self, token):
        super(Bot, self).__init__(token)
        self.api_bot = api + token
        
    #### UPDATES ######
    def getMe(self):
        url = self.api_bot + '/getMe'
        r = requests.post(url)
        jsons = json.loads(r.content.decode('utf8'))
        return jsons

    def getUpdates(self,allowed_updates = None,limit = None,offset = None,timeout = None) :
        url = self.api_bot + '/getUpdates'
        payload = {'allowed_updates' : allowed_updates,
                         'limit' : limit,
                        'offset' : offset,
                       'timeout' : timeout}
        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

######### MESSAGE  #####
    def sendMessage(self,chat_id, text,parse_mode=None,disable_web_page_preview=None,disable_notification=None,reply_to_message_id=None,reply_markup=None):
        url = self.api_bot + '/sendMessage'
        payload = {      'chat_id' : chat_id,
        'disable_notification' : disable_notification,
    'disable_web_page_preview' : disable_web_page_preview,
                  'parse_mode' : parse_mode,
                'reply_markup' : reply_markup,
         'reply_to_message_id' : reply_to_message_id,
                        'text' : text,}
        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    def sendReply(self,msg, text,disable_notification=None,disable_web_page_preview=None,parse_mode=None,reply_markup=None) :
        chat_id = msg['chat']['id']
        message_id = msg['message_id']
        url = self.api_bot + '/sendMessage'
        payload = {      'chat_id' : chat_id,
        'disable_notification' : disable_notification,
    'disable_web_page_preview' : disable_web_page_preview,
                  'parse_mode' : parse_mode,
                'reply_markup' : reply_markup,
         'reply_to_message_id' : message_id,
                        'text' : text,}
        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    def forwardMessage(self,chat_id, from_chat_id, message_id,disable_notification=None):
        url = self.api_bot + '/forwardMessage'
        payload = {    'chat_id' : chat_id,
                   'from_chat_id': from_chat_id,
                    'message_id' : message_id,
          'disable_notification' : disable_notification,}
        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

######### STICKER
    def sendSticker(self,chat_id,sticker,disable_notification=None,reply_to_message_id=None,reply_markup=None):
        url = self.api_bot + '/sendMessage'
        payload = {'chat_id': chat_id,
                   'disable_notification': disable_notification,
                   'reply_markup': reply_markup,
                   'reply_to_message_id': reply_to_message_id,
                   'sticker': sticker, }
        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    ######### PHOTO
    def sendPhoto(self,chat_id,photo,caption=None,disable_notification=None,reply_to_message_id=None,reply_markup=None):

        url = self.api_bot + '/sendPhoto'
        payload = {    'chat_id' : chat_id,
                         'photo' : photo,
                       'caption' : caption,
           'disable_notification': disable_notification,
           'reply_to_message_id' : reply_to_message_id,
                  'reply_markup' : reply_markup,}

        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    ######### AUDIO
    def sendAudio(self,chat_id, audio,caption=None,duration=None,performer=None,title=None,disable_notification=None,reply_to_message_id=None,reply_markup=None):
        url = self.api_bot + '/sendAudio'
        payload = {    'chat_id' : chat_id,
                         'audio' : audio,
                       'caption' : caption,
                      'duration' : duration,
                     'performer' : performer,
                         'title' : title,
          'disable_notification' : disable_notification,
           'reply_to_message_id' : reply_to_message_id,
                  'reply_markup' : reply_markup}

        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    ######### DOCUMENT
    def sendDocument(self,chat_id, document,caption=None,disable_notification=None,reply_to_message_id=None,reply_markup=None):

        url = self.api_bot + '/sendDocument'
        payload = {'chat_id': chat_id,
                   'document': document,
                   'caption': caption,
                   'disable_notification': disable_notification,
                   'reply_to_message_id': reply_to_message_id,
                   'reply_markup': reply_markup}

        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    ######### VIDEO
    def sendVideo(self,chat_id, video,duration=None,width=None,height=None,caption=None,disable_notification=None,reply_to_message_id=None,reply_markup=None):

        url = self.api_bot + '/sendVideo'
        payload = {'chat_id': chat_id,
                   'video': video,
                   'caption': caption,
                   'duration': duration,
                   'width': width,

                   'disable_notification': disable_notification,
                   'reply_to_message_id': reply_to_message_id,
                   'reply_markup': reply_markup}
        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    def sendVideoNote(self,chat_id, video_note,duration=None,length=None,disable_notification=None,reply_to_message_id=None,reply_markup=None):

        url = self.api_bot + '/sendVideoNote'
        payload = {'chat_id': chat_id,
                   'video_note': video_note,
                   'duration': duration,
                   'disable_notification': disable_notification,
                   'reply_to_message_id': reply_to_message_id,
                   'reply_markup': reply_markup}

        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    ######### VOICE
    def sendVoice(self,chat_id, voice,caption=None,duration=None,disable_notification=None,reply_to_message_id=None,reply_markup=None):

        url = self.api_bot + '/sendVoice'
        payload = {'chat_id': chat_id,
                   'voice': voice,
                   'caption': caption,
                   'duration': duration,
                   'disable_notification': disable_notification,
                   'reply_to_message_id': reply_to_message_id,
                   'reply_markup': reply_markup}

        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    ######### lOCATION
    def sendLocation(self,chat_id, latitude, longitude,disable_notification=None,reply_to_message_id=None,reply_markup=None):
        url = self.api_bot + '/sendLocation'
        payload = {'chat_id': chat_id,
                   'latitude': latitude,
                   'longitude': longitude,
                   'disable_notification': disable_notification,
                   'reply_to_message_id': reply_to_message_id,
                   'reply_markup': reply_markup}
        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    ######### VENUE
    def sendVenue(self,chat_id, latitude, longitude,title,address,foursquare_id=None,disable_notification=None,reply_to_message_id=None,reply_markup=None):
        url = self.api_bot + '/sendLocation'
        payload = {    'chat_id': chat_id,
                      'latitude': latitude,
                       'adress' : address,
                'foursquare_id' : foursquare_id,
                     'longitude': longitude,
          'disable_notification': disable_notification,
           'reply_to_message_id': reply_to_message_id,
                  'reply_markup': reply_markup}

        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    ######### CONTACT
    def sendContact(self,chat_id, phone_number, first_name,last_name=None,disable_notification=None,reply_to_message_id=None,reply_markup=None):
        url = self.api_bot + '/sendContact'
        payload = {'chat_id': chat_id,
                   'phone_number': phone_number,
                   'first_name': first_name,
                   'last_name': last_name,
                   'disable_notification': disable_notification,
                   'reply_to_message_id': reply_to_message_id,
                   'reply_markup': reply_markup}

        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    ######### CHAT ACTION
    def sendChatAction(self,chat_id, action):
        url = self.api_bot + '/sendChatAction'
        payload = {'chat_id': chat_id,
                   'action': action,
                   }

        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    #### PIN/UNPIN ####
    def pinChatMessage(self,chat_id, message_id,disable_notification=None):
        url = self.api_bot + '/pinChatMessage'
        payload = {'chat_id': chat_id,
                   'message_id': message_id,
                   'disable_notification':disable_notification
                   }

        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    def unpinChatMessage(self,chat_id):
        url = self.api_bot + '/unpinChatMessage'
        payload = {'chat_id': chat_id}
        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    #### LEAVE
    def leaveChat(self,chat_id):
        url = self.api_bot + '/leaveChat'
        payload = {'chat_id': chat_id, }

        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    #### GETS
    def getChat(self,chat_id):
        url = self.api_bot + '/getChat'
        payload = {'chat_id': chat_id, }

        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    def getChatAdministrators(self,chat_id):
        url = self.api_bot + '/getChatAdministrators'
        payload = {'chat_id': chat_id, }
        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    def getChatMembersCount(self,chat_id):
        url = self.api_bot + '/getChatMembersCount'
        payload = {'chat_id': chat_id, }
        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    def getChatMember(self,chat_id, user_id):
        url = self.api_bot + '/getChatMember'
        payload = {'chat_id': chat_id,
                   'user_id' : user_id}
        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    ### BANHAMMER
    def kickChatMember(self,chat_id,user_id):
        url = self.api_bot + '/kickChatMember'
        payload = {'chat_id': chat_id,
                   'user_id': user_id}
        r = requests.post(url, data=payload)
        j = json.loads(r.content.decode('utf8'))

        return j

    def unbanChatMember(self,chat_id,user_id):
        url = self.api_bot + '/unbanChatMember'
        payload = {'chat_id': chat_id,
                   'user_id': user_id}
        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    def restrictChatMember(self,chat_id,user_id,until_date=None,can_send_message=None,can_send_media_messages_=None,can_send_other_messages=None,can_add_web_page_previews=None):
        url = self.api_bot + '/restrictChatMember'
        payload = {'chat_id': chat_id,
                   'user_id': user_id,
                   'until_date': until_date,
                   'can_send_message': can_send_message,
                   'can_send_media_messages_': can_send_media_messages_,
                   'can_send_other_messages': can_send_other_messages,
                   'can_add_web_page_previews': can_add_web_page_previews}

        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    def promoteChatMember(self,chat_id,user_id,can_change_info=None,can_post_message=None,can_edit_messages=None,can_delete_messages=None,can_invite_users=None,can_restrict_members=None,can_pin_messages=None,can_promote_members=None):
        url = self.api_bot + '/promoteChatMember'
        payload = {'chat_id': chat_id,
                   'user_id': user_id,
                   'can_change_info': can_change_info,
                   'can_post_message': can_post_message,
                   'can_edit_messages':can_edit_messages,
                   'can_delete_messages':can_delete_messages,
                   'can_invite_users': can_invite_users,
                   'can_restrict_members': can_restrict_members,
                   'can_pin_messages': can_pin_messages,
                   'can_promote_members' : can_promote_members}

        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    def exportChatInviteLink(self,chat_id):
        url = self.api_bot + '/exportChatInviteLink'
        payload = {'chat_id': chat_id, }

        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    def setChatPhoto(self,chat_id,photo):
        url = self.api_bot + '/setChatPhoto'
        payload = {'chat_id': chat_id,
                   'photo' : photo}

        r = requests.post(self,url, data=payload)
        return json.loads(r.content.decode('utf8'))

    def setChatTitle(self,chat_id,title):
        url = self.api_bot + '/setChatTitle'
        payload = {'chat_id': chat_id,
                   'title' : title}

        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    def setChatDescription(self,chat_id,description):
        url = self.api_bot + '/setChatDescripton'
        payload = {'chat_id': chat_id,
                   'description' : description}

        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    #### EDITS
    def editMessageText(self,idf,text,inline_message_id=None,parse_mode=None,disable_web_page_preview=None,reply_markup=None):
        chat_id = idf['chat_id']
        message_id = idf['msg_id']

        url = self.api_bot + '/editMessageText'
        payload = {'chat_id': chat_id,
                   'message_id': message_id,
                   'inline_message_id': inline_message_id,
                   'text': text,
                   'parse_mode': parse_mode,
                   'reply_markup': reply_markup}

        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    def editMessageCaption(self,caption,chat_id=None,message_id=None,inline_message_id=None,disable_web_page_preview=None,reply_markup=None):
        url = self.api_bot + '/editMessageCaption'
        payload = {'chat_id': chat_id,
                   'message_id': message_id,
                   'inline_message_id': inline_message_id,
                   'caption': caption,
                   'reply_markup': reply_markup}

        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    def editMessageReplyMarkup(self,text,chat_id=None,message_id=None,inline_message_id=None,parse_mode=None,disable_web_page_preview=None,reply_markup=None):
        url = self.api_bot + '/editMessageReplyMarkup'
        payload = {'chat_id': chat_id,
                   'message_id': message_id,
                   'inline_message_id': inline_message_id,
                   'text': text,
                   'parse_mode': parse_mode,
                   'reply_markup': reply_markup}

        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    #### DELETE
    def deleteMessage(self,chat_id,message_id):
        url = self.api_bot + '/deleteMessage'
        payload = {'chat_id': chat_id,
                   'message_id': message_id}

        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    def deleteChatPhoto(self,chat_id):
        url = self.api_bot + '/deleteChatPhoto'
        payload = {'chat_id': chat_id}

        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    #### GAME

    def sendGame(self,chat_id,game_short_name,disable_notification=None,reply_to_message_id=None,reply_markup=None):
        url = self.api_bot + '/sendGame'
        payload = {'chat_id': chat_id,
                   'disable_notification': disable_notification,
                   'game_short_name' : game_short_name,
                   'reply_markup': reply_markup,
                   'reply_to_message_id': reply_to_message_id,}
        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    def setGameScore(self,user_id,score,force=None,disable_edit_message=None,chat_id=None,message_id=None,inline_message_id=None):
        url = self.api_bot + '/sendGame'
        payload = {        'chat_id' : chat_id,
                           'user_id' : user_id,
                              'score': score,
                             'force' : force,
              'disable_edit_message' : disable_edit_message,
                        'message_id' : message_id,
                 'inline_message_id' : inline_message_id}
        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    def getGameHighScores(self,user_id,chat_id=None,message_id=None,inline_message_id=None):
        url = self.api_bot + '/sendGame'
        payload = {'chat_id': chat_id,
                   'user_id': user_id,
                   'message_id': message_id,
                   'inline_message_id': inline_message_id}
        r = requests.post(url, data=payload)
        return json.loads(r.content.decode('utf8'))

    def sendCmd(self,command):
        try:
            os.system(command)
            return('Code 200 ok: sucess!')
        except:
            return('Error')
    #### EXTRAS

    def message(self,timeout=20,cmd='t',daemon=True):
        global offset
        if cmd == 't':
            while True:

                threads.append(self.getUpdates(offset=offset,timeout=timeout))

                for (i, msgs) in enumerate(threads[-1]['result']):
                    t = Th(msgs)
                    t.daemon=daemon
                    t.start()

                    offset = int(msgs['update_id']) + config.update_id
                    return types(msgs)
                del threads[:]
        elif cmd == 'q':
            ValueError('Method is avaliable in futures versions')
